! Ahha basic turn 25-06-2002
! Tools over 50 on negative tool post (Rear tool post on Front TP M/C)
tool_def

tool_def_end

tape_start
text '; Description here for file window'
out
text '; programme details'
out
text ';'
out
text ';'
out
text ';'
out

crc_dir_last=0
first_t=1
feed_last=0
p_last=0

option code_part_profile
option roll_angle 179
block step 1
block start 0
! block on


text ' G21'
text ' *                         ; Metric programme'
out

text ' G90'
text ' *                         ; In absolute'
out

text ' G40'
text ' *                         ; Make sure radius offsets are off'
out
tape_end
text ' T0000'
text ' *              ; Use T0 offsets as tool change position'
out
text ' G00 Z0.0 X0.0'
text ' *      ; Park position at end of programme'
out
text ' M05'
text ' *                ; Turn spindle off'
out
text ' S0.'
text ' *                ; Set S to 0'
out

text ' M30'
text ' *                ; End of programme, rewind, prompt to run again'
out
block off

rapid
if tool_num>49 x=-x
if tool_num>49 if crc_dir#0 crc_dir=3-crc_dir
if g_last#0 text ' G00'
if crc_dir#crc_dir_last set ' G4' crc_dir 
if x_last#x set ' X' x 43p
if z_last#z set ' Z' z 43p
text ' *'
out

g_last=0
crc_dir_last=crc_dir

return

feed
if tool_num>49 x=-x
if tool_num>49 if crc_dir#0 crc_dir=3-crc_dir
if crc_dir#crc_dir_last set ' G4' crc_dir

if g_last#1 text ' G01'
if x_last#x set ' X' x 43p
if z_last#z set ' Z' z 43p
feed_per_minute=feed
if feed<0 feed_per_minute=abs(feed*spin)
if feed_last#feed set ' F' feed_per_minute 33p 
text ' *'
out
crc_dir_last=crc_dir
g_last=1
feed_last=feed
return

arc
if tool_num>49 x=-x
if tool_num>49 xs=-xs
if tool_num>49 xc=-xc
if tool_num>49 if crc_dir#0 crc_dir=3-crc_dir
if tool_num>49 arc_dir=5-arc_dir
if arc_dir=cw if g_last#2 set ' G' 2 2lt
if arc_dir=ccw if g_last#3 set ' G' 3 2lt
set ' X' x 43p
set ' Z' z 43p
set ' I' xc-xs 43p
set ' K' zc-zs 43p
text ' *'

out

g_last=2
if arc_dir=ccw g_last=3

cycle_start
return

cycle_point
return

cycle_end
return

toolchange
first=0
if first_t#1 set ' T' tool_last 2l
if first_t#1 text '00'
if first_t#1 text ' *'
if first_t#1 out
first_t=0
text ' T0000'
text ' *                       ; use T0 offset as tool change position' 
out
text ' G0 Z0.0 X0.0'
text ' *                ; Tool change position'
out


if tool_num<10 set ' T' tool_num 2l
if tool_num<10 set '' tool_num 2l
if tool_num>9 set ' T' tool_num 2t
if tool_num>9 set '' tool_num 2t

tool_last=tool_num
text ' *                       ; Set current tool offset'
out
text ' M06'
text ' *                         ; Prompt for tool change'
out



if spin_mode=surf text ' *** surface speed not supported ***'
if spin_mode=surf out

if feed_mode=fpr feed=feed*spin
set ' F' feed 3p
feed_last=feed
text ' *                        ; Set feed rate for current tool'
out

if spin_mode=surf text ' *** surface speed not supported ***'
if spin_mode=surf out

if spin_mode=rpm set ' S' spin 4tp
text ' *                      ; Set spindle speed'
out

if spin_dir=cw text ' M03'
if spin_dir=ccw text ' M04'
text ' *                         ; Turn spindle on'
out

text ' G0 Z0'
text ' *                       ; May be needed if in constant contouring mode '
out

g_last=-999
x_last=-999
y_last=-999
z_last=-999
f_last=-999

profile_start    ! same as rapid move
if tool_num>49 x=-x
if tool_num>49 crc_dir=3-crc_dir

if g_last#0 text ' G00'
if crc_dir#crc_dir_last set ' G4' crc_dir  
if x_last#x set ' X' x 43p
if z_last#z set ' Z' z 43p
text ' *'
out

g_last=0
crc_dir_last=crc_dir

return

profile_end
!text ' G40'
!text ' *                ; Make sure radius offsets are off'
!out
!crc_dir=0
return

!thread_cycle
text 'thread cycle'
if tool_num>49 xs=-xs
if tool_num>49 xc=-xc
if tool_num>49 xe=-xe
set ' x start' xs 43p
set ' z start' zs 43p
set ' x end' xe 43p
set ' z end' ze 43p
set ' depth ' depth 43p
set ' depth1 ' depth1 p
set ' pitch ' pitch 43p
out

set ' starts ' starts
set ' angle ' angle p
set ' chase ' chase
out
return

thread_pass
if first#0 goto thread

text ' #3851=1'
text ' *'
out
text ' #3850=0'
text ' *'
out
text ' #3850=1'
text ' *'
out
first=1
:thread
text ' G33'
set ' Z' ze 43p
if p_last#pitch set ' F' Pitch 43p
text ' *'
out

g_last=33
p_last=pitch

return
